﻿using ELTE.TodoList.Persistence.DTO;
using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.TodoList.Desktop.ViewModel
{
    public class ItemViewModel : ViewModelBase
    {
        private int _id;

        public int Id
        {
            get { return _id; }
            set { _id = value; OnPropertyChanged(); }
        }

        private String _name;

        public String Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged(); }
        }

        private String _description;

        public String Description
        {
            get { return _description; }
            set { _description = value; OnPropertyChanged(); }
        }

        private DateTime _deadline;

        public DateTime Deadline
        {
            get { return _deadline; }
            set { _deadline = value; OnPropertyChanged(); }
        }

        private byte[] _image;

        public byte[] Image
        {
            get { return _image; }
            set { _image = value; OnPropertyChanged(); }
        }

        private int _listId;

        public int ListId
        {
            get { return _listId; }
            set { _listId = value; OnPropertyChanged(); }
        }

        public ItemViewModel ShallowClone()
        {
            return (ItemViewModel)this.MemberwiseClone();
        }

        public void CopyFrom(ItemViewModel rhs)
        {
            Id = rhs.Id;
            Name = rhs.Name;
            Description = rhs.Description;
            Deadline = rhs.Deadline;
            Image = rhs.Image;
            ListId = rhs.ListId;
        }

        public static explicit operator ItemViewModel(ItemDto dto) => new ItemViewModel
        {
            Id = dto.Id,
            Name = dto.Name,
            Description = dto.Description,
            Deadline = dto.Deadline,
            Image = dto.Image,
            ListId = dto.ListId
        };

        public static explicit operator ItemDto(ItemViewModel vm) => new ItemDto
        {
            Id = vm.Id,
            Name = vm.Name,
            Description = vm.Description,
            Deadline = vm.Deadline,
            Image = vm.Image,
            ListId = vm.ListId
        };

    }
}
